using Indotalent.Infrastructure.Database;
using MediatR;
using Microsoft.EntityFrameworkCore;

namespace Indotalent.Features.Sales.SalesQuotation.Cqrs;

public record DeleteSalesQuotationByIdCommand(string Id) : IRequest<bool>;

public class DeleteSalesQuotationByIdHandler : IRequestHandler<DeleteSalesQuotationByIdCommand, bool>
{
    private readonly AppDbContext _context;
    public DeleteSalesQuotationByIdHandler(AppDbContext context) => _context = context;

    public async Task<bool> Handle(DeleteSalesQuotationByIdCommand request, CancellationToken cancellationToken)
    {
        var entity = await _context.SalesQuotation
            .FirstOrDefaultAsync(x => x.Id == request.Id, cancellationToken);

        if (entity == null) return false;

        _context.SalesQuotation.Remove(entity);
        await _context.SaveChangesAsync(cancellationToken);
        return true;
    }
}